diff -uwr sourceold/scripts/WWAudioClass.h source/scripts/WWAudioClass.h
--- sourceold/scripts/WWAudioClass.h	2012-02-17 15:02:45.624023400 +0800
+++ source/scripts/WWAudioClass.h	2012-04-14 04:09:47.830078100 +0800
@@ -36,6 +36,7 @@
 typedef void *HSAMPLE;
 typedef void *H3DSAMPLE;
 typedef void *H3DPOBJECT;
+typedef void *HSTREAM;
 typedef signed int HTIMER;
 typedef void (_stdcall  *LPFNSOSCALLBACK)		(SoundSceneObjClass *sound_obj, uint32 user_param);
 typedef void (_stdcall  *LPFNEOSCALLBACK)		(SoundSceneObjClass *sound_obj, uint32 user_param);
@@ -254,7 +255,7 @@
 	SoundBufferClass *	Get_Sound_Buffer (FileClass &file, const char *string_id, bool is_3d);
 	SoundBufferClass *	Get_Sound_Buffer (const char *filename, bool is_3d);
 	SoundBufferClass *	Find_Cached_Buffer (const char *string_id);
-	SoundBufferClass *	Create_Sound_Buffer (FileClass &file, const char *string_id, bool is_3d);
+	SHADERS_API SoundBufferClass *	Create_Sound_Buffer (FileClass &file, const char *string_id, bool is_3d);
 	SoundBufferClass *	Create_Sound_Buffer (unsigned char *file_image, unsigned long bytes, const char *string_id, bool is_3d);
 	SHADERS_API bool						Cache_Buffer (SoundBufferClass *buffer, const char *string_id);
 	bool						Free_Cache_Space (int bytes);
diff -uwr sourceold/scripts/WarFactoryGameObj.h source/scripts/WarFactoryGameObj.h
--- sourceold/scripts/WarFactoryGameObj.h	2011-10-11 21:40:43.303710900 +0800
+++ source/scripts/WarFactoryGameObj.h	2012-05-23 11:16:03.893554600 +0800
@@ -22,7 +22,7 @@
 	~WarFactoryGameObj (void);
 	virtual	void						Init( void );
 	void									Init (const WarFactoryGameObjDef & definition);
-	const WarFactoryGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const WarFactoryGameObjDef &	Get_Definition (void) const;
 	WarFactoryGameObj *				As_WarFactoryGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/WarFactoryGameObjDef.h source/scripts/WarFactoryGameObjDef.h
--- sourceold/scripts/WarFactoryGameObjDef.h	2011-10-11 21:40:40.850585900 +0800
+++ source/scripts/WarFactoryGameObjDef.h	2012-05-06 16:37:05.425695300 +0800
@@ -26,6 +26,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (WarFactoryGameObjDef, VehicleFactoryGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/WeaponClass.h source/scripts/WeaponClass.h
--- sourceold/scripts/WeaponClass.h	2011-11-22 14:49:49.184570300 +0800
+++ source/scripts/WeaponClass.h	2012-05-23 10:58:06.363281200 +0800
@@ -100,7 +100,7 @@
 	float				Get_Recoil_Time( void )		{ return Definition->RecoilTime; }
 	float				Get_Recoil_Scale( void )	{ return Definition->RecoilScale; }
 	void				Set_Total_Rounds( int num );
-	int				Get_Total_Rounds( void );
+	SCRIPTS_API int				Get_Total_Rounds( void );
 	void Import_Ammo_Info(int16 ammoInfo);
 	int16 Export_Ammo_Info();
 	void				Add_Rounds( int num );
@@ -117,7 +117,7 @@
 	bool				Is_Loaded( void )							{ return (ClipRounds != 0); }
 	bool				Is_Reload_OK( void );
 	bool				Is_Reload_Needed( void )				{ return !Is_Loaded() && Is_Reload_OK(); }
-	float				Get_Range( void );
+	SCRIPTS_API float				Get_Range( void );
 	bool				Is_Model_Update_Needed( void )	{ return (UpdateModel == WEAPON_MODEL_UPDATE_IS_NEEDED); }
 	void				Reset_Model_Update( void )			{ UpdateModel = WEAPON_MODEL_UPDATE_NOT_NEEDED; CurrentAnimState = (WeaponAnimState)-1; }
 	bool				Is_Anim_Update_Needed( void )		{ return ( NextAnimState != CurrentAnimState ); }
diff -uwr sourceold/scripts/anticheat.ini source/scripts/anticheat.ini
--- sourceold/scripts/anticheat.ini	2012-02-18 13:32:47.225585900 +0800
+++ source/scripts/anticheat.ini	2012-04-21 09:47:27.628906200 +0800
@@ -113,3 +113,11 @@
 909e932deec23ec75da3744306051b83=builtin_fxaa_sm3_hq.fxo
 1e7fca47542d374462af2fb81ec8a87c=builtin_fxaa_sm3_mq.fxo
 96d98d3a8dc579e76d9b57798a093936=builtin_fxaa_sm3_lq.fxo
+d0d6f19985a0423689531c7dee54b969=C&C_Canyon.lsd
+fad3a89c5605396475d9cd00a30ab1d4=C&C_Canyon.ldd
+f3875e9a955255b7cfb77c02f75fafd1=C&C_Canyon.lsd
+e57ab26c4790da800eb289e0518744df=C&C_Canyon.ldd
+2f760ea711b97cafa952bfbd5e990ab8=C&C_Canyon.mix
+18f1d1600b147d3ad8fdc91bc968ec95=tank_stealth_idle.wav
+9dc7f9fe39e97122f164dec1dbd1bdc4=tank_stealth_start.wav
+68cb626de41e5c24b0fc38879cc4ee1e=tank_stealth_stop.wav
Only in source/scripts: aow_intruders.cpp
Only in source/scripts: aow_intruders.h
Only in source/scripts: cNetEvent.h
diff -uwr sourceold/scripts/cPlayer.h source/scripts/cPlayer.h
--- sourceold/scripts/cPlayer.h	2011-10-11 21:56:41.257812500 +0800
+++ source/scripts/cPlayer.h	2012-05-23 11:03:51.978515600 +0800
@@ -68,8 +68,8 @@
 	void Get_Player_String(int id,WideStringClass &str,bool b);
 	void Increment_Kills();
 	void Increment_Deaths();
-	void Set_Kills(int kills);
-	void Set_Deaths(int deaths);
+	SCRIPTS_API void Set_Kills(int kills);
+	SCRIPTS_API void Set_Deaths(int deaths);
 
 	bool god; // 1876
 	WideStringClass PlayerName; // 1880
Only in source/scripts: cScTextObj.h
Only in source/scripts: cTeam.h
diff -uwr sourceold/scripts/definition.cpp source/scripts/definition.cpp
--- sourceold/scripts/definition.cpp	2011-10-11 23:03:55.115234300 +0800
+++ source/scripts/definition.cpp	2012-04-17 01:14:01.802734300 +0800
@@ -65,3 +65,19 @@
 	}
 	return true;
 }
+
+#ifdef DDBEDIT
+void DefinitionClass::Dump(FileClass &file)
+{
+	for (int i = 0;i < this->Get_Parameter_Count();i++)
+	{
+		ParameterClass *param = this->Lock_Parameter(i);
+		param->Dump(file);
+		this->Unlock_Parameter(i);
+	}
+}
+
+void DefinitionClass::DumpPhys(FileClass &phys)
+{
+}
+#endif
diff -uwr sourceold/scripts/dllmain.cpp source/scripts/dllmain.cpp
--- sourceold/scripts/dllmain.cpp	2012-02-27 12:49:54.797328100 +0800
+++ source/scripts/dllmain.cpp	2012-05-28 21:47:07.567382800 +0800
@@ -293,6 +293,7 @@
 	AddHostHook = (ahh)Address(tt,"AddHostHook");
 	AddRefillHook = (arh)Address(tt,"AddRefillHook");
 	AddLoadLevelHook = (allh)Address(tt,"AddLoadLevelHook");
+	AddPreLoadLevelHook = (allh)Address(tt,"AddPreLoadLevelHook");
 	AddGameOverHook = (allh)Address(tt,"AddGameOverHook");
 	AddThinkHook = (allh)Address(tt,"AddThinkHook");
 	AddPlayerJoinHook = (apjh)Address(tt,"AddPlayerJoinHook");
@@ -306,6 +307,8 @@
 	Get_Vehicle_Limit = (gvl)Address(tt,"Get_Vehicle_Limit");
 	Set_Air_Vehicle_Limit = (svl)Address(tt,"Set_Air_Vehicle_Limit");
 	Get_Air_Vehicle_Limit = (gvl)Address(tt,"Get_Air_Vehicle_Limit");
+	Set_Naval_Vehicle_Limit = (svl)Address(tt,"Set_Naval_Vehicle_Limit");
+	Get_Naval_Vehicle_Limit = (gvl)Address(tt,"Get_Naval_Vehicle_Limit");
 	Send_Message = (sm)Address(tt,"Send_Message");
 	Send_Message_Player = (smp)Address(tt,"Send_Message_Player");
 	Commands->Display_Health_Bar = (void(*)( GameObject * object, bool display ))Address(tt,"New_Display_Health_Bar");
@@ -347,6 +350,8 @@
 	GetExplosionObj = (geo)Address(tt,"GetExplosionObj");
 	SetExplosionObj = (seo)Address(tt,"SetExplosionObj");
 	Update_Network_Object = (uno)Address(tt,"Update_Network_Object");
+	Send_Client_Text = (sct)Address(tt,"Send_Client_Text");
+	Send_Client_Announcement = (sca)Address(tt,"Send_Client_Announcement");
 	gttv GetTTVersion = (gttv)Address(tt,"GetTTVersion");
 	Commands->Control_Enable = (void(*)( GameObject * obj, bool enable ))Address(tt,"New_Control_Enable");
 	AddShaderNotify = (asn)Address(tt,"AddShaderNotify");
@@ -391,6 +396,7 @@
 	Get_Team_Credits = (gtc)Address(tt,"Get_Team_Credits");
 	addConnectionAcceptanceFilter = (addConnectionAcceptanceFilterType)Address(tt, "addConnectionAcceptanceFilter");
 	removeConnectionAcceptanceFilter = (removeConnectionAcceptanceFilterType)Address(tt, "removeConnectionAcceptanceFilter");
+	Is_WOL_User = (iwu)Address(tt, "Is_WOL_User");
 	Evict_Client = (ec)Address(tt,"Evict_Client");
 	Get_Current_Map_Index = (gcmi)Address(tt,"Get_Current_Map_Index");
 	Get_Player_List = (gpl)Address(tt,"Get_Player_List");
@@ -399,6 +405,8 @@
 	Set_Map = (smx)Address(tt,"Set_Map");
 	Get_Game_Definitions = (ggd)Address(tt,"Get_Game_Definitions");
 	Get_Client_Serial_Hash = (gcsh)Address(tt,"Get_Client_Serial_Hash");
+	Get_Tech_Level = (gml)Address(tt,"Get_Tech_Level");
+	Set_Tech_Level = (sw)Address(tt,"Set_Tech_Level");
 	ssc ttssc = (ssc)Address(tt,"Set_Script_Commands");
 	ttssc(commands);
 #ifdef SSGM
